package org.lifolab.mathtables;

import java.util.Random;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MathTablesActivity extends Activity {
	
    private Button[] answers;
	private int right_answer;
	private long start_time;
	private int right_answers;
	private int score;
	private int wrong_answers;

	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        answers = new Button[] {
            (Button) findViewById(R.id.answer0),
            (Button) findViewById(R.id.answer1),
            (Button) findViewById(R.id.answer2),
            (Button) findViewById(R.id.answer3)
        };
    }
    
    public void startGame(View object) {
    	((Button) object).setEnabled(false);
    	((Button) findViewById(R.id.stop)).setEnabled(true);
    	for ( Button answer : answers )
    		answer.setEnabled(true);
    	((EditText) findViewById(R.id.log)).setText("");
    	right_answers = 0;
    	wrong_answers = 0;
    	score = 0;
    	askQuestion();
    }
    
    public void stopGame(View object) {
    	((Button) object).setEnabled(false);
    	((Button) findViewById(R.id.start)).setEnabled(true);
    	for ( Button answer : answers )
    		answer.setEnabled(false);
    	EditText summary = (EditText) findViewById(R.id.log);
    	summary.append("\n====================\n");
    	summary.append("Right answers: "+right_answers+"\n");
    	summary.append("Wrong answers: "+wrong_answers+"\n");
    	summary.append("Final score: "+score+"\n");
    }

	public void answer(View object) {
		long delta_time = System.currentTimeMillis()-start_time;
		Button answer_given = (Button) object;
		TextView question = (TextView) findViewById(R.id.question);
		EditText log = (EditText) findViewById(R.id.log);
		for ( int i = 0 ; i < answers.length ; i++ )
    		if ( answers[i] == answer_given ) {
    			String log_text = question.getText()+" = "+answer_given.getText()+" ";
    			int answer_points = determinePoints(delta_time);
    			if ( i == right_answer ) {
    				right_answers++;
        			score += answer_points;
    				log_text += "RIGHT - "+score+" ("+answer_points+")";
    			} else {
    				wrong_answers++;
        			score -= answer_points;
    				log_text += "WRONG - "+score+" ("+answer_points+")";
    			}
    			log.append(log_text+"\n");
    		}
		askQuestion();
	}

	private void askQuestion() {
    	int op1 = new Random().nextInt(10)+1;
    	int op2 = new Random().nextInt(10)+1;
    	((TextView) findViewById(R.id.question)).setText(op1+" x "+op2);
    	right_answer = new Random().nextInt(4);
    	for ( int i = 0 ; i < answers.length ; i++ )
    		if ( i == right_answer )
    			answers[i].setText(op1*op2+"");
    		else answers[i].setText(((((
    			op1*op2+(new Random().nextInt(2) == 0 ? -1 : 1)*(new Random().nextInt(20)+10)
    		)%100)+100)%100)+"");
    	start_time = System.currentTimeMillis();
	}

    private int determinePoints(long delta_time) {
    	if ( delta_time < 1500 )
    		return 15;
    	else if ( delta_time < 2000 )
    		return 10;
    	else if ( delta_time < 2400 )
    		return 5;
    	else if ( delta_time < 2900 )
    		return 1;
    	return 0;
	}

}