package org.homenet.ehiahi.whereisthounet;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

import android.location.Location;
import android.net.wifi.ScanResult;

public class DataBuffer {

	private Map<String, String> last_valid_info = new HashMap<String, String>();
	
	public synchronized void logGPS(Location location) {
		last_valid_info.put("latitude", location.getLatitude()+"");
		last_valid_info.put("longitude", location.getLongitude()+"");
		last_valid_info.put("has_altitude", location.hasAltitude()+"");
		last_valid_info.put("altitude", location.getAltitude()+"");
		last_valid_info.put("time", location.getTime()+"");
	}

	public synchronized void logWIFI(List<ScanResult> results) {
		String[] networks = new String[results.size()];
		int i = 0;
		for ( ScanResult result : results ) {
			networks[i++] = "SSID|"+result.SSID+";"+
				"signal_level|"+result.level+";"+
				"frequency|"+result.frequency+";"+
				"BSSID|"+result.BSSID+";"+
				"capabilities|"+result.capabilities;
		}
		last_valid_info.put("networks_number", results.size()+"");
		last_valid_info.put("networks", Arrays.toString(networks));
	}

	public synchronized String toString() {
		String string = "";
		for ( String key : last_valid_info.keySet() )
			string += key+"="+last_valid_info.get(key)+"\t";
		last_valid_info = new HashMap<String, String>();
		return string;
	}

	public synchronized JSONObject toJson(String timestamp) throws JSONException {
		JSONObject json = new JSONObject();
		json.put("timestamp", timestamp+"");
		for ( String key : last_valid_info.keySet() )
			json.put(key, last_valid_info.get(key)+"");
		last_valid_info = new HashMap<String, String>();
		return json;
	}

	public synchronized boolean wasUpdated() {
		return last_valid_info.size() == 7;  // At this moment, 7 fields
	}
	
}
