package org.homenet.ehiahi.whereisthounet;

import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;

public class GWLLocationListener implements LocationListener {

	private WhereIsThouNetActivity activity;
	private DataBuffer info;
	private LocationManager location_manager;

	public GWLLocationListener(WhereIsThouNetActivity activity,
			DataBuffer info, LocationManager location_manager) {
		this.activity = activity;
		this.info = info;
		this.location_manager = location_manager;
//		location_manager.requestLocationUpdates(
//			LocationManager.NETWORK_PROVIDER, 1000, 0, this
//		);
		location_manager.requestLocationUpdates(
			LocationManager.GPS_PROVIDER, 1000, 0, this
		);
		activity.logMessage("GWLListener: started");
	}

	@Override
	public void onLocationChanged(Location location) {
		activity.updateGPS(
			location.getLatitude(), location.getLongitude(),
			location.getAltitude()
		);
		info.logGPS(location);
	}

	@Override
	public void onProviderDisabled(String arg0) {
		activity.logMessage("PD: "+arg0);
	}

	@Override
	public void onProviderEnabled(String arg0) {
		activity.logMessage("PE: "+arg0);
	}

	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
		activity.logMessage("SC: "+arg0);
	}

	public void stop() {
		activity.logMessage("GWLListener: stopped");
		location_manager.removeUpdates(this);
	}
	
}
