package org.homenet.ehiahi.whereisthounet;

public class WIFIScanInducerThread extends Thread {

	private static final int SCAN_INTERVAL = 1250;
	private WhereIsThouNetActivity activity;
	private volatile boolean isRunning = true;
	private WiFiScanReceiver scan_receiver;

	public WIFIScanInducerThread(WhereIsThouNetActivity activity,
			WiFiScanReceiver scan_receiver) {
		this.activity = activity;
		this.scan_receiver = scan_receiver;
	}

	@Override
	public void run() {
		super.run();
		activity.logMessage("WIFISIThread: started");
		while ( isRunning ) {
			try {
				sleep(SCAN_INTERVAL);
				if ( scan_receiver.hasTerminated() )
					scan_receiver.startScan();
			} catch (InterruptedException e) {
				activity.logMessage("WIFISIThread: sleep interrupted");
			}
		}
		activity.logMessage("WIFISIThread: stopped");
	}
	
	public void stopExecution() {
		isRunning = false;
	}

}
