package org.homenet.ehiahi.whereisthounet;

import java.util.List;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiManager;

public class WiFiScanReceiver extends BroadcastReceiver {

	private WhereIsThouNetActivity activity;
	private WifiManager wifi_manager;
	private DataBuffer info;
	private volatile boolean active_scan = false;

	public WiFiScanReceiver(WhereIsThouNetActivity activity,
			WifiManager wifi_manager, DataBuffer info) {
	    super();
	    this.wifi_manager = wifi_manager;
	    this.info = info;
	    this.activity = activity;
	}

	@Override
	public void onReceive(Context context, Intent intent) {
		List<ScanResult> results = wifi_manager.getScanResults();
		String networks_list = "";
		if ( results != null )
			for ( ScanResult result : results )
				networks_list += result.SSID+", ";
		if ( !networks_list.equals("") )
			networks_list = networks_list.substring(
				0, networks_list.length()-2
			);
		activity.updateWIFI(results.size(), networks_list);
		info.logWIFI(results);
		active_scan = false;
	}

	public boolean hasTerminated() {
		return !active_scan;
	}

	public void startScan() {
		active_scan = true;
		wifi_manager.startScan();
	}

}
